## dde-kwin 5.4.26

=== CMakeLists.txt ===
project(DDEKWin)

set(PROJECT_NAME "dde-kwin")

if (NOT PROJECT_VERSION)
    set(PROJECT_VERSION "0.0.1")
endif()

if (NOT PROJECT_VERSION_MAJOR)
    set(PROJECT_VERSION_MAJOR 0)
endif()

add_definitions(
    -DPROJECT_NAME=\\"${PROJECT_NAME}\\"
    -DPROJECT_VERSION=\\"${PROJECT_VERSION}\\"
)

#when "KWIN_VERSION > KWIN_VERSION_CHECK(5, 18, 90, 0)"
find_path(
    KWaylandServerPath
    blur_interface.h
    /usr/include/KWaylandServer
    /usr/local/include/KWaylandServer
    )
if(KWaylandServerPath)
    add_definitions(-DKWaylandServerPath)
endif()

if (${CMAKE_SYSTEM_PROCESSOR} STREQUAL "mips64")
    set(CMAKE_CXX_FLAGS "-O3 -ftree-vectorize -march=loongson3a -mhard-float -mno-micromips -mno-mips16 -flax-vector-conversions  -mloongson-ext2 -mloongson-mmi -Wl,--as-needed,-O1 -fno-stack-protector")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-need -fPIE")
    # 1050 security testing,security hardening
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-all -z relro -z now -z noexecstack -pie")
    set(CMAKE_EXE_LINKER_FLAGS "-pie")
endif()

find_package(Qt5Core)
get_target_property(QT_QMAKE_EXECUTABLE ${Qt5Core_QMAKE_EXECUTABLE} IMPORTED_LOCATION)

macro(query_qmake args output)
    exec_program(${QT_QMAKE_EXECUTABLE} ARGS -query ${args} OUTPUT_VARIABLE ${output} RETURN_VALUE exitCode)

    if(NOT ${exitCode} EQUAL 0)
        message(FATAL_ERROR "exec ${QT_QMAKE_EXECUTABLE} failed, with args: ${args}, error message: ${output}")
    endif()
endmacro()

query_qmake("QT_INSTALL_PLUGINS" QT_INSTALL_PLUGINS)

set(PLUGIN_INSTALL_PATH ${QT_INSTALL_PLUGINS}/platforms)
# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
# Create code from a list of Qt designer ui files
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

if (NOT KWIN_VERSION)
    find_package(KDecoration2 REQUIRED)
    set(KWIN_VERSION ${KDecoration2_VERSION})
endif()

if (KWIN_VERSION)
    message("kwin version: ${KWIN_VERSION}")
    string(REPLACE "." ";" KWIN_VERSION_LIST ${KWIN_VERSION})
    list(APPEND KWIN_VERSION_LIST 0 0 0 0)

    if (NOT KWIN_VER_MAJ)
        list(GET KWIN_VERSION_LIST 0 KWIN_VER_MAJ)
    endif()

    if (NOT KWIN_VER_MIN)
        list(GET KWIN_VERSION_LIST 1 KWIN_VER_MIN)
    endif()

    if (NOT KWIN_VER_PAT)
        list(GET KWIN_VERSION_LIST 2 KWIN_VER_PAT)
    endif()

    if (NOT KWIN_VER_BUI)
        list(GET KWIN_VERSION_LIST 3 KWIN_VER_BUI)
    endif()

    add_definitions(
        -DKWIN_VERSION_STR=\\"${KWIN_VERSION}\\"
        -DKWIN_VERSION_MAJ=${KWIN_VER_MAJ}
        -DKWIN_VERSION_MIN=${KWIN_VER_MIN}
        -DKWIN_VERSION_PAT=${KWIN_VER_PAT}
        -DKWIN_VERSION_BUI=${KWIN_VER_BUI}
    )
endif()

add_subdirectory(configures)
set(DDE_KWIN_SUPPORTED_VERSION "5.21.5")
if (${KWIN_VERSION} STRLESS ${DDE_KWIN_SUPPORTED_VERSION} OR  ${KWIN_VERSION} STREQUAL ${DDE_KWIN_SUPPORTED_VERSION})
    add_subdirectory(plugins)
    add_subdirectory(scripts)
    add_subdirectory(deepin-wm-dbus)
    add_subdirectory(tabbox)
    if (BUILD_TESTING)
        add_subdirectory(tests)
    endif()
endif()

=== configures/CMakeLists.txt ===
configure_file(kwin_no_scale.in kwin_no_scale)

install(
    FILES
    kglobalshortcutsrc
    kwinrc
    kwinrulesrc
    klaunchrc
    kdeglobals
    DESTINATION
    "/etc/xdg"
)

install_files("/bin" FILES ${CMAKE_CURRENT_BINARY_DIR}/kwin_no_scale)

=== deepin-wm-dbus/CMakeLists.txt ===
set(TARGET_PATH "${CMAKE_INSTALL_PREFIX}/bin")
set(TARGET_NAME "deepin-wm-dbus")

find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(KF5Config REQUIRED)
find_package(KF5WindowSystem REQUIRED)
find_package(KF5GlobalAccel REQUIRED)
find_package(DtkCore REQUIRED)
find_package(PkgConfig REQUIRED)

option(DISABLE_DEEPIN_WM "disable compatibility with deepin-wm" OFF)

if (DISABLE_DEEPIN_WM)
    set(DEEPIN_WM_PREFIX "<!-- By \"CONFIG+=DISABLE_DEEPIN_WM\"")
    set(DEEPIN_WM_SUFFIX "-->")
    add_definitions(-DDISABLE_DEEPIN_WM)
else()
    pkg_search_module(GSETTINGS REQUIRED gsettings-qt)
endif()

configure_file(com.deepin.wm.xml.in com.deepin.wm.xml)
configure_file(com.deepin.wm.service.in com.deepin.wm.service)

install_files(
    "/share/dbus-1/interfaces"
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/com.deepin.wm.xml
)
install_files(
    "/share/dbus-1/services"
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/com.deepin.wm.service
)

qt5_add_dbus_adaptor(
    wm_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/com.deepin.wm.xml
    deepinwmfaker.h
    DeepinWMFaker
)
qt5_add_dbus_interface(
    wm_SRCS
    ../plugins/platforms/plugin/org.kde.kwin.KWinUtils.xml
    kwinutils_interface
)

add_executable(
    ${TARGET_NAME}
    deepinwmfaker.cpp
    main.cpp
    ${wm_SRCS}
)

target_include_directories(
    ${TARGET_NAME}
    PRIVATE
    ${GSETTINGS_INCLUDE_DIRS}
)

target_link_libraries(
    ${TARGET_NAME}
    Qt5::Core
    Qt5::DBus
    KF5::ConfigCore
    KF5::WindowSystem
    KF5::GlobalAccel
    dtkcore
    ${GSETTINGS_LDFLAGS}
)

install_targets("/bin" deepin-wm-dbus)

=== plugins/CMakeLists.txt ===
add_subdirectory(platforms)
add_subdirectory(kdecoration)
add_subdirectory(kwineffects)

=== tests/CMakeLists.txt ===
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fprofile-arcs -ftest-coverage")

set(PROJECT_NAME_TEST
    ${PROJECT_NAME}_test)

find_package(Qt5Test REQUIRED)
find_package(Qt5 CONFIG REQUIRED COMPONENTS Core Gui )
#find_package(Qt5DBus REQUIRED)
find_package(KF5CoreAddons REQUIRED)
find_package(KF5WindowSystem REQUIRED)
find_package(KF5Config REQUIRED)

find_package(Qt5Quick REQUIRED)
find_package(Qt5QuickWidgets REQUIRED)
find_package(KF5GlobalAccel REQUIRED)
find_package(KF5I18n REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5X11Extras REQUIRED)

pkg_search_module(QGSETTINGS REQUIRED IMPORTED_TARGET gsettings-qt)

set( test
    ut_mulitask_model.cpp
    ../plugins/kwineffects/multitasking/multitasking_model.cpp
)

add_executable(${PROJECT_NAME_TEST} ${test})

target_link_libraries(
    ${PROJECT_NAME_TEST}
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::Quick
    Qt5::QuickWidgets
    Qt5::Test
    Qt5::DBus
    Qt5::X11Extras
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::WindowSystem
    KF5::GlobalAccel
    KF5::I18n
    PkgConfig::QGSETTINGS
    Qt5::X11Extras
    xcb
    kwineffects
)

include_directories(../plugins/platforms/lib)

add_test(NAME dde-test COMMAND ${PROJECT_NAME_TEST})
add_custom_target(test
    COMMAND echo " =================== TEST BEGIN ==================== "
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
    COMMAND ${CMAKE_BINARY_DIR}/tests/${PROJECT_NAME_TEST}
    COMMAND echo " =================== TEST END ==================== "
)

add_dependencies(test ${PROJECT_NAME_TEST})

=== plugins/kwineffects/CMakeLists.txt ===
find_package(Qt5 CONFIG REQUIRED COMPONENTS Core Gui)
find_package(KF5CoreAddons REQUIRED)
find_package(KF5WindowSystem REQUIRED)

set(INSTALL_PATH "${QT_INSTALL_PLUGINS}/kwin/effects/plugins")

add_subdirectory(scissor-window)
add_subdirectory(blur)
add_subdirectory(multitasking)
add_subdirectory(black-screen)

=== plugins/kwineffects/scissor-window/CMakeLists.txt ===
set(TARGET_NAME "scissor-window")

add_library(
    ${TARGET_NAME} MODULE
    main.cpp
    scissorwindow.cpp
    glsl.qrc
)

target_link_libraries(
    ${TARGET_NAME}
    PUBLIC
    Qt5::Core
    Qt5::Gui
    PRIVATE
    KF5::CoreAddons
    KF5::WindowSystem
)

option(DISABLE_LIB_KWIN_XCB "Don't use libkwin-xcb" OFF)

if (DISABLE_LIB_KWIN_XCB)
    add_definitions(-DDISBLE_DDE_KWIN_XCB)
else()
    include_directories(../../platforms/lib)
    target_link_libraries(${TARGET_NAME} kwin-xcb)
endif()

install(TARGETS ${TARGET_NAME} DESTINATION ${INSTALL_PATH})

=== plugins/platforms/lib/CMakeLists.txt ===
set(TARGET_NAME "kwin-xcb")

find_package(Qt5Core REQUIRED)
find_package(Qt5X11Extras REQUIRED)
find_package(Qt5Qml REQUIRED)
find_package(KF5Config REQUIRED)
find_package(KF5WindowSystem REQUIRED)
find_package(KF5CoreAddons REQUIRED)

if (${KF5WindowSystem_VERSION_MINOR} GREATER 45)
    add_definitions(-DKWINDOWSYSTEM_NO_QWIDGET)
else()
    find_package(Qt5Widgets REQUIRED)
endif()

add_library(
    ${TARGET_NAME} SHARED
    kwinutils.cpp
    vtablehook.cpp
)

set_target_properties(
    ${TARGET_NAME} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

target_link_libraries(
    ${TARGET_NAME}
    Qt5::Core
    Qt5::Qml
    Qt5::X11Extras
    KF5::ConfigCore
    KF5::WindowSystem
    KF5::CoreAddons
)

if (KWIN_LIBRARY_PATH)
    # 强制链接libkwin.so，kwin开发库未提供 libkwin.so，需要构建脚本自行创建链接到 /usr/lib/.../libkwin.so.x.x.x 的软连接
    find_library(lib_kwin NAMES kwin PATHS ${KWIN_LIBRARY_PATH} NO_DEFAULT_PATH)
    if (EXISTS ${lib_kwin})
        target_link_libraries(${TARGET_NAME} ${lib_kwin})
    else()
        message(SEND_ERROR "Can't find libkwin.so from \"${KWIN_LIBRARY_PATH}\"")
    endif()
endif()

if (CMAKE_INSTALL_LIBDIR)
    install_targets("/${CMAKE_INSTALL_LIBDIR}" ${TARGET_NAME})
elseif (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    install(TARGETS ${TARGET_NAME} DESTINATION "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
else()
    install_targets("/lib" ${TARGET_NAME})
endif()

set(INCLUDE_OUTPUT_PATH "${CMAKE_INSTALL_PREFIX}/include/${PROJECT_NAME}")

install_files(
    "/include/${PROJECT_NAME}"
    FILES
    vtablehook.h
    common.h
    kwinutils.h
)

configure_file(${PROJECT_NAME}.pc.in ${PROJECT_NAME}.pc)
if (CMAKE_INSTALL_LIBDIR)
    install_files("/${CMAKE_INSTALL_LIBDIR}/pkgconfig" FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc)
elseif (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    install(FILES FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc DESTINATION "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/pkgconfig")
else()
    install_files("/lib/pkgconfig" FILES ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}.pc)
endif()

=== debian/changelog ===
dde-kwin (5.4.26-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 21 Mar 2022 16:32:11 +0800

dde-kwin (5.4.23-1) unstable; urgency=medium

  * Bug fix:
    + 109640 fix: the splitmenu is not available on wayland platform.

 -- Lei Su <sulei@uniontech.com>  Thu, 10 Feb 2022 15:25:10 +0800

dde-kwin (5.4.22-1) unstable; urgency=medium

  * Feat:
    + 97260 feat: add func about maxi button long press

 -- Lei Su <sulei@uniontech.com>  Mon, 10 Jan 2022 15:56:06 +0800

dde-kwin (5.4.21-1) unstable; urgency=medium

  * Bug fix:
    + 104607 chore: add a dependency on 'kwin-wayland'.

 -- Lei Su <sulei@uniontech.com>  Thu, 30 Dec 2021 19:09:00 +0800

dde-kwin (5.4.20-1) unstable; urgency=medium

  * Bug fix:
    + 109751 fix: cancle decoration hover event when the client is moving

 -- Lei Su <sulei@uniontech.com>  Mon, 27 Dec 2021 15:11:25 +0800

dde-kwin (5.4.19-1) unstable; urgency=medium

  * Bug fix:
    + fix: Cannot use shortcut keys to bring up the multitasking view.

  * Unit test:
    + test: modify the unit test working directory

 -- Lei Su <sulei@uniontech.com>  Thu, 16 Dec 2021 10:17:07 +0800

dde-kwin (5.4.18-1) unstable; urgency=medium

  * Bug fix:
    + fix: adjust menu style
    + fix: add a root accessible.name for alt + tab
    + fix: Fix the problem that the maximized window cannot fill the screen
    + fix: Some shortcuts are registered only in wayland mode.
    + fix: Maximize split screen menu disappears

 -- Lei Su <sulei@uniontech.com>  Fri, 03 Dec 2021 15:47:30 +0800

dde-kwin (5.4.17-1) unstable; urgency=medium

  * Bug fix:
    + fix: Alt + TAB module support for automated testing has been temporarily withdrawn

 -- Lei Su <sulei@uniontech.com>  Sat, 20 Nov 2021 16:33:33 +0800

dde-kwin (5.4.16-1) unstable; urgency=medium

  * Bug fix:
    + fix: add security hardening for security testing

 -- Lei Su <sulei@uniontech.com>  Sat, 20 Nov 2021 15:59:21 +0800

dde-kwin (5.4.14-1) unstable; urgency=medium

  * Bug fix:
    + Fix the problem that the switcher thumbnail cannot be switched caused by efb6b4cd7 submission.

 -- Lei Su <sulei@uniontech.com>  Mon, 15 Nov 2021 14:33:50 +0800

dde-kwin (5.4.13-1) unstable; urgency=medium

  * feat: The 'wayland' branch joins the 'master' branch

 -- Lei Su <sulei@uniontech.com>  Thu, 11 Nov 2021 21:09:23 +0800

dde-kwin (5.3.19-1) unstable; urgency=medium

  * Bug fix:
    + 87758 fix: After S3 wakes up, the screen flashes when opening the file and then closing it

 -- Lei Su <sulei@uniontech.com>  Mon, 30 Aug 2021 10:51:20 +0800

dde-kwin (5.3.18-1) unstable; urgency=medium

  * Bug fix:
    + 63174 optimize work thumbnail
    + 66832 in sw_64 platform, the second background be white in multitasking
    + 82889 add Tibetan and Uighur translation for 'No windows' and 'Drag upwards to remove'

 -- Xu Yongrui <xuyongrui@uniontech.com>  Wed, 04 Aug 2021 14:51:37 +0800

dde-kwin (5.3.16-1) unstable; urgency=medium

  * unit test
    + output test result to ut-report.txt

 -- Lei Su <sulei@uniontech.com>  Fri, 11 Jun 2021 11:38:18 +0800

dde-kwin (5.3.15-1) unstable; urgency=medium

  * unit test
    + fix: repair the error by cppcheck

 -- Lei Su <sulei@uniontech.com>  Fri, 04 Jun 2021 17:32:40 +0800

dde-kwin (5.3.14-1) unstable; urgency=medium

  * unit test

 -- Lei Su <sulei@uniontech.com>  Wed, 02 Jun 2021 13:20:30 +0800

dde-kwin (5.3.13-1) unstable; urgency=medium

  * Bug fix:
    + 68673, 67845 Shortcut Super+Shift+number works in a wrong way
    + 66630 Delete first workspace bigbackground didn't refresh
    + 69809 Highlighter disappear when dragging desktop thumbnail
    + 78218 Crashing when open multitasking view
    + 68672 Shortcut meta+shift+padnumber didn't work

 -- Lei Su <sulei@uniontech.com>  Mon, 31 May 2021 14:54:00 +0800

dde-kwin (5.3.12-1) unstable; urgency=medium

  * Bug fix:
    + refactor: Remove line number in translate file.

 -- Lei Su <sulei@uniontech.com>  Wed, 19 May 2021 20:37:53 +0800

dde-kwin (5.3.11-1) unstable; urgency=medium

  * add memory test.

 -- Lei Su <sulei@uniontech.com>  Wed, 12 May 2021 20:14:13 +0800

dde-kwin (5.3.10-1) unstable; urgency=medium
  * Bug fix:
    + 72368 fix: Compositing is able to enable in Euler.

 -- Lei Su <sulei@uniontech.com>  Tue, 11 May 2021 13:24:35 +0800

dde-kwin (5.3.9-1) UNRELEASED; urgency=medium

  * Bug fix:
    + 70513, 69821 fix: The community version of the multi tasking view is full of icons.
    + 49208, 72368 fix: Add RPM package detection server script.

 -- Lei Su <sulei@uniontech.com>  Wed, 21 Apr 2021 18:09:00 +0800

dde-kwin (5.3.8-1) UNRELEASED; urgency=medium

  * Bug fix:
    + 60642 fix: Click "X" with fingers to turn off insensitivity.

 -- Lei Su <sulei@uniontech.com>  Fri, 02 Apr 2021 17:11:55 +0800

dde-kwin (5.3.7-1.1) unstable; urgency=medium

  * Bug fix:
  + Conflicts that occur when translating files.

 -- Lei Su <sulei@uniontech.com>  Wed, 17 Mar 2021 17:35:56 +0800

dde-kwin (5.3.6-1.1) unstable; urgency=medium

  * Bug fix:
    + 31415 add numpad to global shortcut.
    + 66325 Current workspace changed even didn't add new workspace.
    + 66627 Delete hint show when a workspace thumbnail drag to other one.
    + 58520 There is no popup notify when there is no window in the workspace.
    + 61749 when JM Display card, we close window effect. 

 -- Lei Su <sulei@uniontech.com>  Wed, 17 Mar 2021 16:09:18 +0800

dde-kwin (5.3.5-1) unstable; urgency=medium

  * Task:
    + 61378 Add translation file.
  * Bug fix:
    + 65167 Shortcut "alt+shift+~" crash in multitasking.
    + 64912 Multitasking crash due to window position.

 -- Lei Su <sulei@uniontech.com>  Tue, 09 Mar 2021 17:44:12 +0800

dde-kwin (5.15.1000.3-1) unstable; urgency=medium

  * update for klu/pgv master branch
  * To automate the packaging with correct versions

 -- wugang <wugang@uniontech.com>  Tue, 28 Sep 2021 09:45:38 -0300

dde-kwin (0.0.1-1) unstable; urgency=medium

  * Initial release



=== debian/control ===
Source: dde-kwin
Section: devel
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.com>
Build-Depends: debhelper (>=9),
 cmake,
 qtbase5-dev,
 qtbase5-private-dev,
 libqt5x11extras5-dev,
 libxcb1-dev,
 libkf5globalaccel-dev,
 libkf5windowsystem-dev,
 libkf5coreaddons-dev,
 kwin-dev,
 libkf5config-dev,
 libdtkcore-dev,
 libgsettings-qt-dev,
 libfontconfig1-dev,
 libfreetype6-dev,
 libglib2.0-dev,
 libxrender-dev,
 libmtdev-dev,
 qttools5-dev-tools,
 qttools5-dev,
 deepin-gettext-tools,
 extra-cmake-modules,
 libkdecorations2-dev,
 libkf5wayland-dev,
 libkf5i18n-dev,
 qtdeclarative5-dev,
 libdtkgui-dev,
 libxcb-composite0-dev,
 libxcb-damage0-dev
Standards-Version: 3.9.8
Homepage: https://github.com/linuxdeepin/dde-kwin

Package: dde-kwin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 kwin-x11, kwin-wayland, plasma-framework, libkf5globalaccel-bin,
 qml-module-qtquick-controls2, qml-module-qtquick-templates2
Description: KWin configures/plugins on the DDE
 Let kwin work well in the Deepin Desktop Environment.

Package: dde-kwin-dev
Section: libdevel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Developer package of dde-kwin
 Provide dde-kwin plugin implementation basis files.

## dde-kwin 5.5.11

=== configures/CMakeLists.txt ===
option(USE_KWIN_NO_SCALE "use deepin LD_PRELOAD kwin_no_scale" ON)

install(
    FILES
    kglobalshortcutsrc
    kwinrc
    kwinrulesrc
    klaunchrc
    kdeglobals
    DESTINATION
    "/etc/xdg"
)

if (USE_KWIN_NO_SCALE)
    configure_file(kwin_no_scale.in kwin_no_scale)
    install_files("/bin" FILES ${CMAKE_CURRENT_BINARY_DIR}/kwin_no_scale)
endif()

=== plugins/kwineffects/CMakeLists.txt ===
find_package(Qt5 CONFIG REQUIRED COMPONENTS Core Gui)
find_package(KF5CoreAddons REQUIRED)
find_package(KF5WindowSystem REQUIRED)

set(INSTALL_PATH "${QT_INSTALL_PLUGINS}/kwin/effects/plugins")

option(ENABLE_BUILTIN_SCISSOR_WINDOW "enable deepin built-in scissor window plugin" ON)
option(ENABLE_BUILTIN_BLUR "enable deepin built-in blur plugin" ON)
option(ENABLE_BUILTIN_MULTITASKING "enable deepin built-in multitasking plugin" ON)
option(ENABLE_BUILTIN_BLACK_SCREEN "enable deepin built-in black screen plugin" ON)

if (ENABLE_BUILTIN_SCISSOR_WINDOW)
    add_subdirectory(scissor-window)
endif()

if (ENABLE_BUILTIN_BLUR)
    add_subdirectory(blur)
endif()

if (ENABLE_BUILTIN_MULTITASKING)
    add_subdirectory(multitasking)
endif()

if (ENABLE_BUILTIN_BLACK_SCREEN)
    add_subdirectory(black-screen)
endif()

=== debian/changelog ===
dde-kwin (5.5.11-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Thu, 12 May 2022 10:26:45 +0800

dde-kwin (5.5.10-1) unstable; urgency=medium

  * Bug fix:
    + 123355 fix: no blur effect on dde-grand-search and dde-network-dialog with wayland

 -- Lei Su <sulei@uniontech.com>  Tue, 26 Apr 2022 20:29:53 +0800

dde-kwin (5.5.9-1) unstable; urgency=medium

  * Bug fix:
    + 111891 fix: add shortcut of ScreenshotOcr/ScreenshotScroll/GlobalSearch.

 -- Lei Su <sulei@uniontech.com>  Mon, 18 Apr 2022 15:08:35 +0800

dde-kwin (5.5.8-1) unstable; urgency=medium

  * Bug fix:
    + 96087, 119943, 103388 fix: not blur and two half-width docks on wayland

 -- Lei Su <sulei@uniontech.com>  Thu, 31 Mar 2022 22:05:59 +0800

dde-kwin (5.5.7-1) unstable; urgency=medium

  * feat:
    + feat: remove qt deps for windowtool.

 -- Lei Su <sulei@uniontech.com>  Mon, 28 Mar 2022 18:00:35 +0800

dde-kwin (5.5.6-1.1) unstable; urgency=medium

  * Bug fix:
    + fix: Fix compilation failures.

 -- Lei Su <sulei@uniontech.com>  Fri, 25 Mar 2022 18:57:39 +0800

dde-kwin (5.5.5-1) unstable; urgency=medium

  * feat:
    + 97260 feat: add func about maxi button long press

 -- Lei Su <sulei@uniontech.com>  Fri, 25 Mar 2022 17:53:15 +0800

dde-kwin (5.5.4-1) unstable; urgency=medium

  * Bug fix:
    + 113223 fix: qtcreator split menu style error on x11 platform

 -- Lei Su <sulei@uniontech.com>  Fri, 25 Mar 2022 15:50:28 +0800

dde-kwin (5.5.3-1) unstable; urgency=medium

  * feat:
    + refactor: Refactor the multitasking view.

 -- Lei Su <sulei@uniontech.com>  Mon, 21 Mar 2022 21:21:57 +0800

dde-kwin (5.4.34-1) unstable; urgency=medium

  * Bug fix:
    + 96087, 103388 fix: transparency of docker/launcher/notification/clipboard on wayland

  * Task:
    + 101855 feat: add style to titlebar menu

 -- Lei Su <sulei@uniontech.com>  Tue, 15 Mar 2022 22:41:38 +0800

dde-kwin (5.4.33-1) unstable; urgency=medium

  * Bug fix:
    + 107455 fix: DDE-kwin cannot call PresentWindows under wayland platform.

 -- Lei Su <sulei@uniontech.com>  Mon, 14 Mar 2022 19:26:40 +0800

## dde-kwin 5.5.24

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,6 +14,12 @@
     -DPROJECT_NAME=\\"${PROJECT_NAME}\\"
     -DPROJECT_VERSION=\\"${PROJECT_VERSION}\\"
 )
+
+option(USE_PLUGINS "use dde-kwin plugins" ON)
+option(USE_SCRIPTS "use scripts" ON)
+option(USE_DEEPIN_WM_DBUS "use deepin-wm dbus service" ON)
+option(USE_TABBOX "use deepin style tabbox" ON)
+option(USE_WINDOW_TOOL "support wayland and x11" ON)
 
 #when "KWIN_VERSION > KWIN_VERSION_CHECK(5, 18, 90, 0)"
 find_path(
@@ -92,13 +98,27 @@
 endif()
 
 add_subdirectory(configures)
-set(DDE_KWIN_SUPPORTED_VERSION "5.21.5")
-if (${KWIN_VERSION} STRLESS ${DDE_KWIN_SUPPORTED_VERSION} OR  ${KWIN_VERSION} STREQUAL ${DDE_KWIN_SUPPORTED_VERSION})
-    add_subdirectory(plugins)
-    add_subdirectory(scripts)
-    add_subdirectory(deepin-wm-dbus)
-    add_subdirectory(tabbox)
-    if (BUILD_TESTING)
-        add_subdirectory(tests)
-    endif()
+
+if (USE_PLUGINS)
+  add_subdirectory(plugins)
 endif()
+
+if (USE_SCRIPTS)
+  add_subdirectory(scripts)
+endif()
+
+if (USE_DEEPIN_WM_DBUS)
+  add_subdirectory(deepin-wm-dbus)
+endif()
+
+if (USE_TABBOX)
+add_subdirectory(tabbox)
+endif()
+
+if (BUILD_TESTING)
+    add_subdirectory(tests)
+endif()
+
+if (USE_WINDOW_TOOL)
+  add_subdirectory(windowtool)
+endif()

=== plugins/CMakeLists.txt ===
add_subdirectory(platforms)

option(ENABLE_KDECORATION "enable deepin kdecoration plugin" ON)

if (ENABLE_KDECORATION)
    add_subdirectory(kdecoration)
endif()

add_subdirectory(kwineffects)

=== scripts/CMakeLists.txt ===
install(
    DIRECTORY
    screenedge/runcommandaction
    screenedge/closewindowaction
    ddeshortcuts
    ddelauncher
    gtkframe
    DESTINATION
    ${CMAKE_INSTALL_PREFIX}/share/kwin/scripts
)

=== tabbox/CMakeLists.txt ===
install(
    DIRECTORY
    thumbnail_grid
    DESTINATION
    ${CMAKE_INSTALL_PREFIX}/share/kwin/tabbox
)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -34,7 +34,6 @@
 
 set( test
     ut_mulitask_model.cpp
-    ../plugins/kwineffects/multitasking/multitasking_model.cpp
 )
 
 add_executable(${PROJECT_NAME_TEST} ${test})

=== windowtool/CMakeLists.txt ===
set(PROJECT_NAME "dde-windowtool")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11 -Wall")

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} )

find_package(X11 REQUIRED)

find_package(KF5Wayland REQUIRED)
# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Gui
    Widgets
REQUIRED)

find_package(Libdrm 2.4.62)
set_package_properties(Libdrm PROPERTIES TYPE OPTIONAL PURPOSE "Required for drm output on Wayland.")
set(HAVE_DRM FALSE)
if(Libdrm_FOUND)
    set(HAVE_DRM TRUE)
endif()

find_package(gbm)
set_package_properties(gbm PROPERTIES TYPE OPTIONAL PURPOSE "Required for egl output of drm backend.")
set(HAVE_GBM FALSE)
if(HAVE_DRM AND gbm_FOUND)
    set(HAVE_GBM TRUE)
endif()

if(HAVE_GBM)
  add_definitions("-DHAVE_GBM")
endif()

set(SC_FILES
    src/XcbWindowLoader.cpp
    src/WaylandWindowLoader.cpp
    src/ScreenRecorder.cpp
    src/WindowInfoLoader.cpp
)

add_library(${PROJECT_NAME} SHARED ${SC_FILES})

set_target_properties(
    ${PROJECT_NAME} PROPERTIES
    VERSION ${PROJECT_VERSION}
    SOVERSION ${PROJECT_VERSION_MAJOR}
)

target_link_libraries(${PROJECT_NAME}  Qt5::Core Qt5::Gui Qt5::Widgets)
target_link_libraries(${PROJECT_NAME}  KF5::WaylandClient)
target_link_libraries(${PROJECT_NAME}  X11)
target_link_libraries(${PROJECT_NAME}  xcb)
target_link_libraries(${PROJECT_NAME}  Libdrm::Libdrm)
target_link_libraries(${PROJECT_NAME}  gbm::gbm)

if (CMAKE_INSTALL_LIBDIR)
    install_targets("/${CMAKE_INSTALL_LIBDIR}" ${PROJECT_NAME})
elseif (CMAKE_LIBRARY_OUTPUT_DIRECTORY)
    install(TARGETS ${PROJECT_NAME} DESTINATION "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
else()
    install_targets("/lib" ${PROJECT_NAME})
endif()

set(SC_HEADERS
  src/WindowInfo.h
  src/XcbWindowLoader.h
  src/WaylandWindowLoader.h
  src/ScreenRecorder.h
  src/WindowInfoLoader.h
)

install(FILES
  ${SC_HEADERS}
  DESTINATION include/windowtool COMPONENT Devel
)

if (BUILD_TESTING)
    add_subdirectory(demo)
endif()

=== plugins/kdecoration/CMakeLists.txt ===
set(TARGET_NAME "deepin-chameleon")

add_definitions(-DTARGET_NAME=\\"${TARGET_NAME}\\")

find_package(Qt5 CONFIG REQUIRED COMPONENTS Core)
find_package(KF5CoreAddons REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(KF5Config REQUIRED)
find_package(KF5WindowSystem REQUIRED)
find_package(KDecoration2 REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
include_directories(${Qt5Core_PRIVATE_INCLUDE_DIRS})
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})

option(DISABLE_LIB_KWIN_XCB "Don't use libkwin-xcb" OFF)

set(CMAKE_CXX_STANDARD 11)

# translations
file(GLOB TS LIST_DIRECTORIES false translations/splitmenu*.ts)
foreach(_ts_file ${TS})
    execute_process(
        COMMAND ${LUPDATE_EXECUTABLE} -recursive ${CMAKE_SOURCE_DIR}/translations -ts ${_ts_file})
    execute_process(COMMAND lrelease ${_ts_file})
endforeach()

add_library(
    ${TARGET_NAME}
    MODULE
    main.cpp
    chameleon.cpp
    chameleontheme.cpp
    chameleonbutton.cpp
    chameleonshadow.cpp
    chameleonconfig.cpp
    chameleonwindowtheme.cpp
    chameleonsplitmenu.cpp
    themes.qrc
)

target_link_libraries(
    ${TARGET_NAME}
    PUBLIC
    Qt5::Core
    Qt5::DBus
    PRIVATE
    KDecoration2::KDecoration
    KF5::CoreAddons
    KF5::ConfigCore
    KF5::WindowSystem
)

if (DISABLE_LIB_KWIN_XCB)
    add_definitions(-DDISBLE_DDE_KWIN_XCB)
else()
    include_directories(../platforms/lib)
    target_link_libraries(${TARGET_NAME} kwin-xcb)
endif()

install(TARGETS ${TARGET_NAME} DESTINATION ${QT_INSTALL_PLUGINS}/org.kde.kdecoration2)

=== plugins/kwineffects/black-screen/CMakeLists.txt ===
set(TARGET_NAME "black-screen")

find_package(KF5Config REQUIRED)
find_package(Qt5DBus REQUIRED)

add_library(
    ${TARGET_NAME} MODULE
    black-screen.cpp
    main.cpp
)

include_directories(../../platforms/lib)

target_include_directories(${TARGET_NAME} PUBLIC
    ${Qt5Core_INCLUDE_DIRS}
    ${Qt5DBus_INCLUDE_DIRS}
)

target_link_libraries(
    ${TARGET_NAME}
    PUBLIC
    Qt5::Core
    Qt5::Gui
    Qt5::DBus
    PRIVATE
    KF5::CoreAddons
    KF5::WindowSystem
    KF5::ConfigCore
)

install(TARGETS ${TARGET_NAME} DESTINATION ${INSTALL_PATH})

=== plugins/platforms/lib/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 find_package(Qt5Core REQUIRED)
 find_package(Qt5X11Extras REQUIRED)
 find_package(Qt5Qml REQUIRED)
+find_package(X11 REQUIRED)
 find_package(KF5Config REQUIRED)
 find_package(KF5WindowSystem REQUIRED)
 find_package(KF5CoreAddons REQUIRED)

=== plugins/platforms/plugin/CMakeLists.txt ===
set(TARGET_NAME "${PROJECT_NAME}-xcb")
set(WAYLAND_TARGET_NAME "${PROJECT_NAME}-wayland")

# 禁止语法树上的 vrp 优化，-O2/-O3 默认开启，会导致测试虚析构函数 HOOK 失败
add_compile_options(-fno-tree-vrp)

find_package(Qt5Core REQUIRED)
find_package(Qt5Quick REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(DtkGui REQUIRED)

include_directories(${Qt5Core_PRIVATE_INCLUDE_DIRS})
include_directories(${Qt5Gui_PRIVATE_INCLUDE_DIRS})
include_directories(../lib)


option(USE_DBUS_MENU "use deepin dbus menu for the window title menu widget" OFF)
option(DISABLE_DXCB "disable DXcb platform plugin" OFF)

if (USE_DBUS_MENU)
    add_definitions(-DUSE_DBUS_MENU)
endif()

if (DISABLE_DXCB)
    add_definitions(-DDISABLE_DXCB)
endif()

qt5_add_dbus_adaptor(
    plugin_SRCS
    org.kde.kwin.KWinUtils.xml
    kwinutils.h
    KWinUtils
)

install_files(
    "/share/dbus-1/interfaces"
    FILES
    org.kde.kwin.KWinUtils.xml
)

qt5_add_dbus_interface(
    wm_infterface_SRCS
    ${PROJECT_SOURCE_DIR}/deepin-wm-dbus/com.deepin.wm.xml.in
    wm_interface
)

# for xcb platform
add_library(
    ${TARGET_NAME} MODULE
    main.cpp
    libkwinpreload.cpp
    ${plugin_SRCS}
    ${wm_infterface_SRCS}
)

target_compile_definitions(
    ${TARGET_NAME}
    PRIVATE
    PLATFORMS_PLUGIN_PATH="${PLUGIN_INSTALL_PATH}"
    TARGET_NAME="${TARGET_NAME}"
)

target_link_libraries(
    ${TARGET_NAME}
    Qt5::Core
    Qt5::DBus
    Qt5::Quick
    Qt5::Widgets
    ${DtkGui_LIBRARIES}
    kwin-xcb
)

# for wayland platform
add_library(
    ${WAYLAND_TARGET_NAME} MODULE
    main_wayland.cpp
    libkwinpreload.cpp
    ${plugin_SRCS}
    ${wm_infterface_SRCS}
)

target_compile_definitions(
    ${WAYLAND_TARGET_NAME}
    PRIVATE
    PLATFORMS_PLUGIN_PATH="${PLUGIN_INSTALL_PATH}"
    TARGET_NAME="${WAYLAND_TARGET_NAME}"
    TRANSLATE_NAME="${TARGET_NAME}"
    WAYLAND_PLATFORM=1
)

target_link_libraries(
    ${WAYLAND_TARGET_NAME}
    Qt5::Core
    Qt5::DBus
    Qt5::Quick
    Qt5::Widgets
    kwin-xcb
)
install(TARGETS ${TARGET_NAME} ${WAYLAND_TARGET_NAME} DESTINATION ${PLUGIN_INSTALL_PATH})

if (NOT CMAKE_BUILD_TYPE MATCHES Debug)
    exec_program(${CMAKE_CURRENT_SOURCE_DIR}/translate_generation.sh OUTPUT_VARIABLE output RETURN_VALUE exit_code)

    if (NOT exit_code EQUAL 0)
        message(SEND_ERROR "Failed to generate translation, exit code=${exit_code}, message=\"${output}\"")
    endif()

    file(GLOB QM_FILES "translations/*.qm")
    install_files("/share/${TARGET_NAME}/translations" FILES ${QM_FILES})
endif()

=== debian/changelog ===
dde-kwin (5.5.24-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 17 Oct 2022 14:23:09 +0800

dde-kwin (5.5.22-1) unstable; urgency=medium

  * Bug fix:
    + 151433 fix: the problem of atl + tab up and down arrow keys switching

 -- Lei Su <sulei@uniontech.com>  Wed, 7 Sep 2022 15:44:58 +0800

dde-kwin (5.5.21-1) unstable; urgency=medium

  * Bug fix:
    + fix: remove special code about override and onscreendisplay,fix the problem of setting corner radius 0 cann't apply.
    + fix: remove some special code about dde and deepin.

 -- Lei Su <sulei@uniontech.com>  Wed, 24 Aug 2022 17:59:58 +0800

dde-kwin (5.5.19-1) unstable; urgency=medium

  * Bug fix:
    + fix: popup window should get blur region from dtk.

 -- Lei Su <sulei@uniontech.com>  Tue, 12 Jul 2022 16:07:58 +0800

dde-kwin (5.5.18-1) unstable; urgency=medium

  * Bug fix:
    + 124157   fix: the client of override type do not scissor window.

 -- Lei Su <sulei@uniontech.com>  Thu, 07 Jul 2022 17:07:44 +0800

dde-kwin (5.5.17-1) unstable; urgency=medium

  * Bug fix:
    + 126389, 124949, 123663 fix: setup viewport the size of allscreens when blur effect drawed.

 -- Lei Su <sulei@uniontech.com>  Tue, 21 Jun 2022 13:50:16 +0800

dde-kwin (5.5.15-1) unstable; urgency=medium

  * Task:
    + 99095 feat: add interface to outside about display rules

 -- Lei Su <sulei@uniontech.com>  Tue, 07 Jun 2022 17:53:12 +0800

dde-kwin (5.5.14-1) unstable; urgency=medium

  * Bug fix:
    + 124417 add checkClientAllowToSplite when splitmenu show

 -- Lei Su <sulei@uniontech.com>  Wed, 01 Jun 2022 14:05:31 +0800

dde-kwin (5.5.13-1) unstable; urgency=medium

  * Bug fix:
    + 123355 fix: blur area did not update when window geomety changed

 -- Lei Su <sulei@uniontech.com>  Thu, 26 May 2022 10:20:24 +0800

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,9 @@
  cmake,
  qtbase5-dev,
  qtbase5-private-dev,
+ libwayland-dev,
+ libdrm-dev (>= 2.4.62~),
+ libgbm-dev,
  libqt5x11extras5-dev,
  libxcb1-dev,
  libkf5globalaccel-dev,
@@ -48,3 +51,4 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Developer package of dde-kwin
  Provide dde-kwin plugin implementation basis files.
+

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT=5

%:
	dh $@ 

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_test:
	:

## dde-kwin 5.5.25

=== configures/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,13 @@
     "/etc/xdg"
 )
 
+install(
+    FILES
+    org.kde.kwin.multitaskview.display.json
+    DESTINATION
+    "/usr/share/dsg/configs/org.kde.kwin"
+)
+
 if (USE_KWIN_NO_SCALE)
     configure_file(kwin_no_scale.in kwin_no_scale)
     install_files("/bin" FILES ${CMAKE_CURRENT_BINARY_DIR}/kwin_no_scale)

=== deepin-wm-dbus/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 
 find_package(Qt5Core REQUIRED)
 find_package(Qt5DBus REQUIRED)
+find_package(X11 REQUIRED)
 find_package(KF5Config REQUIRED)
 find_package(KF5WindowSystem REQUIRED)
 find_package(KF5GlobalAccel REQUIRED)

=== plugins/kwineffects/multitasking/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

set(PLUGIN_NAME "multitasking")
set(PLASMA_RELATIVE_DATA_INSTALL_DIR "plasma")

set(KF5_DEP_VERSION "5.54.0") # handled by release scripts

find_package(ECM 5.54.0  NO_MODULE)

set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${ECM_KDE_MODULE_DIR})

find_package(KF5 ${KF5_DEP_VERSION} REQUIRED
    COMPONENTS
    OPTIONAL_COMPONENTS
        Wayland
)
set_package_properties(KF5Wayland PROPERTIES DESCRIPTION "Integration with the Wayland compositor"
                       TYPE OPTIONAL
                      )
if(KF5Wayland_FOUND)
    set(HAVE_KWAYLAND 1)
endif()

#optional features
find_package(X11 MODULE)
set_package_properties(X11 PROPERTIES DESCRIPTION "X11 libraries"
                       URL "http://www.x.org"
                       TYPE OPTIONAL
                      )
find_package(XCB MODULE COMPONENTS XCB COMPOSITE DAMAGE SHAPE XFIXES RENDER)
set_package_properties(XCB PROPERTIES DESCRIPTION "X protocol C-language Binding"
                       URL "http://xcb.freedesktop.org"
                       TYPE OPTIONAL
                      )
if(X11_FOUND AND XCB_XCB_FOUND)
  set(HAVE_X11 1)
  find_package(Qt5 REQUIRED NO_MODULE COMPONENTS X11Extras)
  #X11_Xrender discovery is done by FindX11
  #add_feature_info("X Rendering Extension (libXrender)" X11_Xrender_FOUND "Support for compositing, rendering operations, and alpha-blending. STRONGLY RECOMMENDED")
endif()

find_package(OpenGL)
set_package_properties(OpenGL PROPERTIES DESCRIPTION "The OpenGL libraries"
                       URL "http://www.opengl.org"
                       TYPE OPTIONAL
                      )

find_package(EGL)
set_package_properties(EGL PROPERTIES
                       PURPOSE "Support for Window Thumbnail on EGL platform"
                       TYPE OPTIONAL
                      )
set(HAVE_EGL ${EGL_FOUND})

if(OPENGL_FOUND AND (${Qt5Gui_OPENGL_IMPLEMENTATION} STREQUAL "GL"))
    set(HAVE_GLX ${HAVE_X11})
else()
    set(HAVE_GLX 0)
endif()

if(HAVE_X11 AND XCB_XCB_FOUND AND XCB_COMPOSITE_FOUND AND XCB_DAMAGE_FOUND)
    set(HAVE_XCB_COMPOSITE TRUE)
else()
    set(HAVE_XCB_COMPOSITE FALSE)
endif()

configure_file(config-x11.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-x11.h)
configure_file(config-plasma.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-plasma.h)

find_package(Qt5Quick REQUIRED)
find_package(Qt5QuickWidgets REQUIRED)
find_package(KF5Config REQUIRED)
find_package(KF5GlobalAccel REQUIRED)
find_package(KF5I18n REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(Qt5LinguistTools REQUIRED)

pkg_search_module(QGSETTINGS REQUIRED IMPORTED_TARGET gsettings-qt)

set(SRCS backgroundimageprovider.cpp imageprovider.cpp multitasking.cpp multitasking_model.cpp background.cpp
    factory.cpp windowthumbnail.cpp thumbmanager.qml PlusButton.qml DesktopBackgroundImage.qml)

# translations
file(GLOB TS LIST_DIRECTORIES false translations/${PLUGIN_NAME}*.ts)
set_source_files_properties(${TS}
    PROPERTIES OUTPUT_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/translations)

qt5_create_translation(QM ${SRCS} ${TS} OPTIONS -locations none)

qt5_add_dbus_interface(
    wm_infterface_SRCS
    ${PROJECT_SOURCE_DIR}/deepin-wm-dbus/com.deepin.wm.xml.in
    wm_interface
)

add_library(
    ${PLUGIN_NAME} MODULE
    ${SRCS}
    ${QM}
    ${wm_infterface_SRCS}
    data.qrc
)

include_directories(../../platforms/lib)

target_link_libraries(
    ${PLUGIN_NAME}
    PUBLIC
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
    Qt5::Quick
    Qt5::QuickWidgets
    PRIVATE
    KF5::ConfigCore
    KF5::CoreAddons
    KF5::WindowSystem
    KF5::GlobalAccel
    KF5::I18n
    PkgConfig::QGSETTINGS
    Qt5::X11Extras
)

install(TARGETS ${PLUGIN_NAME} DESTINATION ${INSTALL_PATH})

=== debian/changelog ===
dde-kwin (5.5.25-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 21 Nov 2022 10:55:16 +0800

## dde-kwin 5.5.25.1

=== CMakeLists.txt ===
set(TARGET_PATH "${CMAKE_INSTALL_PREFIX}/bin")
set(TARGET_NAME "deepin-wm-dbus")

find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(X11 REQUIRED)
find_package(KF5Config REQUIRED)
find_package(KF5WindowSystem REQUIRED)
find_package(KF5GlobalAccel REQUIRED)
find_package(DtkCore REQUIRED)
find_package(PkgConfig REQUIRED)

option(DISABLE_DEEPIN_WM "disable compatibility with deepin-wm" OFF)

if (DISABLE_DEEPIN_WM)
    set(DEEPIN_WM_PREFIX "<!-- By \"CONFIG+=DISABLE_DEEPIN_WM\"")
    set(DEEPIN_WM_SUFFIX "-->")
    add_definitions(-DDISABLE_DEEPIN_WM)
else()
    pkg_search_module(GSETTINGS REQUIRED gsettings-qt)
endif()

configure_file(com.deepin.wm.xml.in com.deepin.wm.xml)
configure_file(com.deepin.wm.service.in com.deepin.wm.service)

install_files(
    "/share/dbus-1/interfaces"
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/com.deepin.wm.xml
)
install_files(
    "/share/dbus-1/services"
    FILES
    ${CMAKE_CURRENT_BINARY_DIR}/com.deepin.wm.service
)

qt5_add_dbus_adaptor(
    wm_SRCS
    ${CMAKE_CURRENT_BINARY_DIR}/com.deepin.wm.xml
    deepinwmfaker.h
    DeepinWMFaker
)
qt5_add_dbus_interface(
    wm_SRCS
    ../plugins/platforms/plugin/org.kde.kwin.KWinUtils.xml
    kwinutils_interface
)

add_executable(
    ${TARGET_NAME}
    deepinwmfaker.cpp
    main.cpp
    ${wm_SRCS}
)

target_include_directories(
    ${TARGET_NAME}
    PRIVATE
    ${GSETTINGS_INCLUDE_DIRS}
)

target_link_libraries(
    ${TARGET_NAME}
    Qt5::Core
    Qt5::DBus
    KF5::ConfigCore
    KF5::WindowSystem
    KF5::GlobalAccel
    dtkcore
    ${GSETTINGS_LDFLAGS}
    ${DtkCore_LIBRARIES}
)

install_targets("/bin" deepin-wm-dbus)

=== demo/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

set(PROJECT_NAME "windowloader")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11 -Wall")

#Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

project(${PROJECT_NAME})

include_directories(SYSTEM ${Qt5Core_PRIVATE_INCLUDE_DIRS})

FILE(GLOB SC_FILES "*.cpp" "*.h")

add_executable(${PROJECT_NAME} ${SC_FILES})

target_link_libraries(${PROJECT_NAME}  dde-windowtool png)

=== kwineffects/blur/CMakeLists.txt ===
set(TARGET_NAME "blur")

find_package(KF5Config REQUIRED)

add_library(
    ${TARGET_NAME} MODULE
    blur.cpp
    blurshader.cpp
    main.cpp
)

include_directories(../../platforms/lib)

target_link_libraries(
    ${TARGET_NAME}
    PUBLIC
    Qt5::Core
    Qt5::Gui
    PRIVATE
    KF5::CoreAddons
    KF5::WindowSystem
    KF5::ConfigCore
)

install(TARGETS ${TARGET_NAME} DESTINATION ${INSTALL_PATH})

=== debian/changelog ===
dde-kwin (5.5.25.1-3) unstable; urgency=medium

  * fix herght 40 -> 24.

 -- LiChengGang <lichenggang@uniontech.com>  Mon, 17 Apr 2023 14:55:40 +0800

dde-kwin (5.5.25-1+rb1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 21 Nov 2022 10:55:16 +0800
